/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <pthread.h>
#include <signal.h>
#include "dlist.h"
#include "face/log.h"
/*included from main.cc*/

void signal_handler(int num) {
    pthread_exit(NULL);
};

void init_signal_handler() {
    struct sigaction action,old_action;
    action.sa_handler=signal_handler;
    action.sa_flags=0;
    sigaction(SIGINT,&action,&old_action);
};

void stop_thread(tDownload *what) {
    if (what->thread_id==0)  return;
    pthread_kill(what->thread_id,SIGINT);
    int *rc;
    pthread_join(what->thread_id,(void **)&rc);
    if (what->who) {
        delete(what->who);
        what->who=NULL;
    };
    what->thread_id=0;
};
