/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <gtk/gtk.h>
#include <stdio.h>
#include "list.h"
#include "../var.h"

GtkWidget *AboutWindow=NULL;

void destroy_about_window() {
    gtk_widget_destroy(AboutWindow);
    AboutWindow=NULL;
    gtk_widget_set_sensitive(MainWindow,TRUE);
};

void init_about_window(...) {
    if (AboutWindow) return;
    AboutWindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_widget_set_usize( GTK_WIDGET (AboutWindow), 400, 105);
    gtk_window_set_policy (GTK_WINDOW(AboutWindow), FALSE,FALSE,FALSE);
    gtk_window_set_title(GTK_WINDOW (AboutWindow), "About");
    gtk_container_border_width(GTK_CONTAINER(AboutWindow),5);
    gtk_widget_show(AboutWindow);
    GtkWidget *box=gtk_vbox_new(FALSE,0);
    GtkWidget *label1=gtk_label_new(VERSION_NAME);
    GtkWidget *label2=gtk_label_new("http://www.krasu.ru/soft/chuchelo");
    GtkWidget *label3=gtk_label_new("Author: Koshelev Maxim");
    GtkWidget *label4=gtk_label_new("e-mail: mdem@chat.ru");
    GtkWidget *Button=gtk_button_new_with_label("Ok");
    gtk_box_pack_start(GTK_BOX(box),label1,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(box),label2,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(box),label3,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(box),label4,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(box),Button,FALSE,FALSE,0);
    gtk_container_add(GTK_CONTAINER(AboutWindow),box);
    gtk_signal_connect(GTK_OBJECT(Button),"clicked",
                       (GtkSignalFunc)destroy_about_window,NULL);
    gtk_signal_connect(GTK_OBJECT(AboutWindow), "delete_event",
                       (GtkSignalFunc)destroy_about_window,NULL);
    GTK_WIDGET_SET_FLAGS(Button,GTK_CAN_DEFAULT);
    gtk_window_set_default(GTK_WINDOW(AboutWindow),Button);
    gtk_widget_show_all(AboutWindow);
    gtk_widget_set_sensitive(MainWindow,FALSE);
};
