/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef MY_DOWNLOAD_EDITOR
#define MY_DOWNLOAD_EDITOR
#include <gtk/gtk.h>
#include "../dlist.h"
#include "../history.h"

class tDEdit{
	tDownload *parent;
	GtkWidget *pass_entry,*user_entry,*path_entry,*url_entry;
	GtkWidget *timeout_entry,*attempts_entry,*sleep_entry;
	GtkWidget *use_pass_check;
	GtkWidget *dir_browser;
	GtkWidget *button;
	public:
		GtkWidget *ok_button,*cancel_button;
		GtkWidget *window;
		tDEdit();
		void init(tDownload *who);
		void init_browser();
		void done_browser();
		void browser_ok();
		int apply_changes();
		void setup_entries();
		void paste_url();
		void select_url();
		void clear_url();
		void done();
		~tDEdit();
};


void init_edit_window(tDownload *what);
GList *make_glist_from_mylist(tHistory *parent);

extern tHistory *UrlHistory;
extern tHistory *PathHistory;

#endif