/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
#ifndef T_LOG_STRING
#define T_LOG_STRING
#include "liststr.h"
#include <time.h>

struct tLogString:public tString{
	int type;
	time_t time;
	tLogString();
	tLogString(char *where, int len,int tp);
	void print();
	~tLogString();
};

class tLog:public tStringList{
	protected:
	time_t start;
	void send_msg(int type,tLogString *what);
	public:
	int MsgQueue;
		void *Window;
		tLog();
		void print();
		void add(char *str,int len,int type);
		void add(char *str,int type);
		void add(char *str);
		void dispose();
		tLogString *last();
		tLogString *next();
		tLogString *first();
		~tLog();
};

struct mbuf{
	long mtype;
	tLogString *what;
	tLog *which;
};

enum{
	LOG_OK,
	LOG_WARNING,
	LOG_SERVER,
	LOG_ERROR
};
#endif