/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include "main.h"
#include "config.h"
#include "face/list.h"
#include "var.h"
//-------------------------------------------------
tMain aa;

char *VERSION_NAME="WebDownloader for X 0.97";

int main(int argc,char **argv) {
    read_config();
    aa.init();
    init_face(argc,argv);
    aa.init_main_log();
    aa.load_defaults();
    if (!GLOBAL_SAVE_PATH)
        GLOBAL_SAVE_PATH=getenv("HOME");
    init_timeouts();
    aa.run();
    return 0;
};
